;==========================================================
; kdc}gbNXƉxZTg{[Q[
; Led15x14.asm
; cputype AT90S4414
;
;	쐬	Nv
;
;==========================================================
;
;==========================================================
; e|[g̓o͐ݒ
;==========================================================

.equ		PA_SET	= 0xFF
; Port A:   PA0 : Output LED C1
;           PA1 : Output     C2
;           PA2 : Output     C3
;           PA3 : Output     C4
;           PA4 : Output     C5
;           PA5 : Output     C6
;           PA6 : Output     C7
;           PA7 : Output     C8
;
.equ		PB_SET	= 0xFF
; Port B:   PB0 : Output LED R1
;           PB1 : Output     R2
;           PB2 : Output     R3
;           PB3 : Output     R4
;           PB4 : Output     R5
;           PB5 : Output     R6
;           PB6 : Output     R7
;           PB7 : Output     R8
;
.equ		PC_SET	= 0x3F
; Port C:   PC0 : Output LED C9
;           PC1 : Output     C10
;           PC2 : Output     C11
;           PC3 : Output     C12
;           PC4 : Output     C13
;           PC5 : Output     C14
;           PC6 : Input  ADXL202 Xout
;           PC7 : Input          Yout
;
.equ		PD_SET	= 0xFF
; Port D:   PD0 : Output LED R9
;           PD1 : Output     R10
;           PD2 : Output     R11
;           PD3 : Output     R12
;           PD4 : Output     R13
;           PD5 : Output     R14
;           PD6 : Output     R15
;           PD7 : Output Sound
;
;
;==========================================================
; SRAM GA
;==========================================================
; 0x0060 - 0x007B	; LED \p
;
;            <---- LOW ----> <-- HIGH --->
;            0 1 2 3 4 5 6 7 0 1 2 3 4 5 6
;
;            R                           R
;    SRAM    1<------------------------>15
;    0x0060  C1
;    0x0062  C2
;    0x0064  C3
;    0x0066  C4
;    0x0068  C5
;    0x006A  C6
;    0x006C  C7
;    0x006E  C8
;    0x0070  C9
;    0x0072  C10
;    0x0074  C11
;    0x0076  C12
;    0x0078  C13
;    0x007A  C14
;
; 0x00A0 - 0x00A3	; xlL̈
;    0x00A0 AX  8bit
;    0x00A1 AX  8bit
;    0x00A2 AY  8bit
;    0x00A3 AY  8bit
;
;
;==========================================================
; f[^pEEPROM
;==========================================================
;
; 0x00 - 0x80 ; ^[Qbgʒu
;               4rbgXʒu(R)
;               4rbgYʒu(C)
;
; 0x80 - 0x9B ; N\ʒu
;               4rbgXʒu(R)
;               4rbgYʒu(C)

;==========================================================
; CN[ht@C
.include	"4414def.inc"

; =========================================================
; .equ e|[g̖O
; =========================================================

.equ		LED_R1_R8	= $18		;PORTB
.equ		LED_R9_R15	= $12		;PORTD
.equ		LED_C1_C8	= $1b		;PORTA
.equ		LED_C9_C14	= $15		;PORTC

; "4414def.inc" Ŗ`
.equ	CS02	=2
.equ	CS01	=1
.equ	CS00	=0

; =========================================================
; .def
; =========================================================

.def	XL_reg	= r0
.def	XH_reg	= r1
.def	YL_reg	= r2
.def	YH_reg	= r3

.def	VXL_reg	= r4
.def	VXH_reg	= r5
.def	VYL_reg	= r6
.def	VYH_reg	= r7

.def	AXL_reg	= r8
.def	AXH_reg	= r9
.def	AYL_reg	= r10
.def	AYH_reg	= r11

.def	LED_X	= r12
.def	LED_Y	= r13

.def	STEG	= r14
.def	STEG0	= r15

.def	tmp		= r16
.def	jmode	= r17

.def	ON_X	= r18
.def	ON_Y	= r19

.def	tmp_L	= r20
.def	tmp_H	= r21

.def	PT_X	= r22
.def	PT_Y	= r23

.def	SOUND_L	= r24
.def	SOUND_H	= r25

.def	LTIM	= r26
.def	LMODE	= r27

;==========================================================
; ZbgxN^
;==========================================================

	rjmp	RESET		;Reset Handler			0000
	nop					;IRQ0					0001
	nop					;IRQ1					0002
	nop					;Timer1 Capture			0003
	nop					;Timer1 CompaerA		0004
	nop					;Timer1 CompaerB		0005
	nop					;Timer1 Overflow		0006
	rjmp	TIM0_INT	;Timer0 Overflow		0007
	nop					;SPI Tansfer Complete
	nop					;UART RX Complete
	nop					;UDR Empty
	nop					;UART TX Complete
	nop					;Analog Comparator

;==========================================================
;==========================================================
; RESET ̃Wv
;==========================================================
RESET:

; =========================================================
; STACK Pointer set
; =========================================================
	ldi	tmp,0x01		; 0x015F
	out	SPH,tmp
	ldi	tmp,0x5F
	out	SPL,tmp

; =========================================================
; SRAM  LED \p̃NA
; =========================================================
	rcall	SRAM_CLR

; =========================================================
; PORT ̏
; =========================================================
	ldi	tmp,0x01		;R1 = high, R2-8 = low
	out	LED_R1_R8,tmp

	ldi	tmp,0x80		;R9-15 = low, Sound OFF(=1)
	out	LED_R9_R15,tmp

	ldi	tmp,0xFE		;C1 = low,C2-8 = high
	out	LED_C1_C8,tmp

	ldi	tmp,0xFF		;C9-14 = high
	out	LED_C9_C14,tmp

; =========================================================
; PORT ̓o͐ݒ
; =========================================================
	ldi	tmp,PA_SET
	out	DDRA,tmp

	ldi	tmp,PB_SET
	out	DDRB,tmp

	ldi	tmp,PC_SET
	out	DDRC,tmp

	ldi	tmp,PD_SET
	out	DDRD,tmp

; =========================================================
; ̑
; =========================================================
	ldi	ON_X,0x00
	ldi	ON_Y,0x00

	ldi	SOUND_L,0x00	;
	ldi	SOUND_H,0xFF

	ldi	jmode,0x10

; EEPROM AhXݒ
	ldi	tmp,0x80
	mov	STEG0,tmp
	
	ldi	LTIM,0x00
	ldi	LMODE,0x00

; =========================================================
;Timer0 Interrupt Enable
; =========================================================
	ldi	tmp,(1<<TOIE0)
	out	TIMSK,tmp

; =========================================================
;Timer0 Prescale ݒ CK/64
; =========================================================
	ldi	tmp,(1<<CS01)+(1<<CS00)
	out	TCCR0,tmp

; =========================================================
;Timer1 Prescale ݒ CK/8
; =========================================================
	ldi	tmp,(1<<CS11)
	out	TCCR1B,tmp

; =========================================================
;Interrupt Enable
; =========================================================
	sei

; =========================================================
; =========================================================
; 荞ݑ҂[v
; =========================================================
loop:
	rjmp	loop

;==========================================================
;==========================================================
; ^C}O荞ݏ[`
;==========================================================
TIM0_INT:

; =========================================================
; TCNT0 set TCNT0  0x80 ݒ肷邱Ƃ
; 荞ݎ 128 * 64 * 0.25 = 2048usƂ
; =========================================================
	ldi		tmp,0x80
	out		TCNT0,tmp

; =========================================================
; jmode gWve[u
; =========================================================

	rcall	TABLE_JMODE
;						 jmode
	rjmp	JMODE_00	;0x00	Q[{
	rjmp	JMODE_01	;0x01
	rjmp	JMODE_02	;0x02
	rjmp	JMODE_03	;0x03
	rjmp	JMODE_04	;0x04
	rjmp	JMODE_05	;0x05
	rjmp	JMODE_06	;0x06
	rjmp	JMODE_07	;0x07
	rjmp	JMODE_08	;0x08
	rjmp	JMODE_09	;0x09
	rjmp	JMODE_10	;0x0A
	rjmp	JMODE_11	;0x0B
	rjmp	JMODE_12	;0x0C
	rjmp	JMODE_13	;0x0D
	rjmp	JMODE_14	;0x0E
	rjmp	JMODE_15	;0x0F

	rjmp	JMODE_00	;0x10	d͎̕\
	rjmp	JMODE_01	;0x11
	rjmp	JMODE_02	;0x12
	rjmp	JMODE_03	;0x13
	rjmp	JMODE_04	;0x14
	rjmp	JMODE_05	;0x15
	rjmp	JMODE_06	;0x16
	rjmp	JMODE_07	;0x17
	rjmp	JMODE_08	;0x18
	rjmp	JMODE_09	;0x19
	rjmp	JMODE_10	;0x1A
	rjmp	JMODE_11	;0x1B
	rjmp	JMODE_12	;0x1C
	rjmp	JMODE_13	;0x1D
	rjmp	JMODE_30	;0x1E
	rjmp	JMODE_31	;0x1F

	rjmp	JMODE_32	;0x20	x菈
	rjmp	JMODE_33	;0x21

;==========================================================
; =========================================================
; jmode == 00
; =========================================================
JMODE_00:
	ldi		tmp,0b11111110	; C1-C14̐ݒ
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111111
	out		LED_C9_C14,tmp

; =========================================================
; LED \p SRAM Addres ̏
	ldi		ZL,0x60			;if CL_reg.0 == 0 then ZL = 0x60

	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 01
; =========================================================
JMODE_01:
	ldi		tmp,0b11111101
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111111
	out		LED_C9_C14,tmp
	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 02
; =========================================================
JMODE_02:
	ldi		tmp,0b11111011
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111111
	out		LED_C9_C14,tmp
	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 03
; =========================================================
JMODE_03:
	ldi		tmp,0b11110111
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111111
	out		LED_C9_C14,tmp
	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 04
; =========================================================
JMODE_04:
	ldi		tmp,0b11101111
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111111
	out		LED_C9_C14,tmp
	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 05
; =========================================================
JMODE_05:
	ldi		tmp,0b11011111
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111111
	out		LED_C9_C14,tmp
	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 06
; =========================================================
JMODE_06:
	ldi		tmp,0b10111111
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111111
	out		LED_C9_C14,tmp
	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 07
; =========================================================
JMODE_07:
	ldi		tmp,0b01111111
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111111
	out		LED_C9_C14,tmp
	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 08
; =========================================================
JMODE_08:
	ldi		tmp,0b11111111
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111110
	out		LED_C9_C14,tmp
	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 09
; =========================================================
JMODE_09:
	ldi		tmp,0b11111111
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111101
	out		LED_C9_C14,tmp
	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 10
; =========================================================
JMODE_10:
	ldi		tmp,0b11111111
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111011
	out		LED_C9_C14,tmp
	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 11
; =========================================================
JMODE_11:
	ldi		tmp,0b11111111
	out		LED_C1_C8,tmp
	ldi		tmp,0b11110111
	out		LED_C9_C14,tmp
	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 12
; =========================================================
JMODE_12:
	ldi		tmp,0b11111111
	out		LED_C1_C8,tmp
	ldi		tmp,0b11101111
	out		LED_C9_C14,tmp
	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 13
; =========================================================
JMODE_13:
	ldi		tmp,0b11111111
	out		LED_C1_C8,tmp
	ldi		tmp,0b11011111
	out		LED_C9_C14,tmp
	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 14
; =========================================================
JMODE_14:
	ldi		tmp,0b11111111	;LED \~
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111111
	out		LED_C9_C14,tmp

	rcall	XOUT_COUNT		;Xx̑

	mov		AXL_reg,tmp_L	;݂̉xWX^ɃZbg
	mov		AXH_reg,tmp_H

	ldi		YL,0xA0			;CfbNXYWX^̐ݒ
	ldi		YH,0x00

	ld		tmp_L,Y+		;xl8bit
	ld		tmp_H,Y+		;            8bit

; N̉xZTXX␳
	sub		AXL_reg,tmp_L	;݂̉x - x
	sbc		AXH_reg,tmp_H

	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 15
; =========================================================
JMODE_15:
	ldi		tmp,0b11111111
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111111
	out		LED_C9_C14,tmp

	rcall	YOUT_COUNT		;Yx̑

	mov		AYL_reg,tmp_L	;݂̉xWX^ɃZbg
	mov		AYH_reg,tmp_H

	ld		tmp_L,Y+		;xl8bit
	ld		tmp_H,Y+		;            8bit

; N̉xZTYX␳
	sub		AYL_reg,tmp_L	;݂̉x - x
	sbc		AYH_reg,tmp_H

; AY 𔽓]ixZŤƁAČtj
	mov		tmp_L,AYL_reg
	mov		tmp_H,AYH_reg

	ldi		tmp,0x00
	mov		AYL_reg,tmp
	mov		AYH_reg,tmp
	sub		AYL_reg,tmp_L
	sbc		AYH_reg,tmp_H

; =========================================================
; X,Y WľvZ
; =========================================================
; xvZ
	add		VXL_reg,AXL_reg		; VX += AX
	adc		VXH_reg,AXH_reg

	add		VYL_reg,AYL_reg		; VY += AY
	adc		VYH_reg,AYH_reg

; ʒuvZ
	add		XL_reg,VXL_reg		;X += VX
	adc		XH_reg,VXH_reg

	add		YL_reg,VYL_reg		;Y += VY
	adc		YH_reg,VYH_reg

; =========================================================
; ݈ʒûw
; XH WX^ 6bit Vtg
; VtgʂȂƁAx̌ʂ傫Ȃ
; =========================================================
	mov		tmp,XH_reg
	mov		ON_X,XL_reg

	ror		tmp			;1bit Vtg
	ror		ON_X

	ror		tmp
	ror		ON_X

	ror		tmp
	ror		ON_X

	ror		tmp
	ror		ON_X

	ror		tmp
	ror		ON_X

	ror		tmp
	ror		ON_X			; LED_ R(X)

; X neg check
	sbrs	XH_reg,7		;if X < 0 then skip
	rjmp	LBL20			;if X >= 0 then goto LBL20
; X < 0  ǂɏՓ
	ldi		ON_X,0x00

; VX check x`FbN
	sbrs	VXH_reg,7		; if VXH_reg,7 == 1 then skip
	rjmp	Next_02			; if VXH_reg,7 == 0 then goto Next_02

; ǂɏՓ˂ꍇ̏
	ldi		tmp,0x00
	mov		XH_reg,tmp		; ʒuύX
	ldi		tmp,0x1F
	mov		XL_reg,tmp
	rjmp	LBL_neg			; x𔽓]

LBL20:
	cpi		ON_X,0x0F
	brmi	Next_02			;if ON_X < 0x0F then goto Next_02

; ON_X < 0x0F @ǂɏՓ
	ldi		ON_X,0x0E		;0000 1110

; VX check x`FbN
	sbrc	VXH_reg,7		; if VXH_reg,7 == 0 then skip
	rjmp	Next_02			; if VXH_reg,7 == 1 then goto Next_02
;
	ldi		tmp,0x03		;ʒuύX
	mov		XH_reg,tmp
	ldi		tmp,0xA0
	mov		XL_reg,tmp

; x𔽓]

LBL_neg:
	rcall	VX_neg

; Sound ON
	ldi		SOUND_L,0xF0	;ǂƂ̏Փˉ
	ldi		SOUND_H,0xFF

Next_02:
; =========================================================
; ݈ʒuY
; YH WX^ 6bit Vtg
; VtgʂȂƁAx̌ʂ傫Ȃ
; =========================================================
	mov		tmp,YH_reg
	mov		ON_Y,YL_reg

	ror		tmp
	ror		ON_Y

	ror		tmp
	ror		ON_Y

	ror		tmp
	ror		ON_Y

	ror		tmp
	ror		ON_Y

	ror		tmp
	ror		ON_Y

	ror		tmp
	ror		ON_Y

; y neg check
	sbrs	YH_reg,7		;if Y < 0 then skip
	rjmp	LBL21			;if Y >= 0 then goto LBL21
; Y < 0 ǂɏՓ
	ldi		ON_Y,0x00

; VY check x`FbN
	sbrs	VYH_reg,7		; if VYH_reg,7 == 1 then skip
	rjmp	Next_03			; if VYH_reg,7 == 0 then goto Next_03

; ǂɏՓ˂ꍇ̏
	ldi		tmp,0x00
	mov		YH_reg,tmp		; ʒuύX
	ldi		tmp,0x1F
	mov		YL_reg,tmp
	rjmp	LBL_neg2		; x𔽓]

LBL21:
	cpi		ON_Y,0x0E
	brmi	Next_03			;if ON_Y < 0x0E then goto Next_03

; ON_Y < 0x0E@ǂɏՓ
	ldi		ON_Y,0x0D		;0000 1101

; VY check x`FbN
	sbrc	VYH_reg,7		; if VYH_reg,7 == 0 then skip
	rjmp	Next_03			; if VYH_reg,7 == 1 then goto Next_03

	ldi		tmp,0x03		;ʒuύX
	mov		YH_reg,tmp
	ldi		tmp,0x60
	mov		YL_reg,tmp
;
; x𔽓]
LBL_neg2:
	rcall	VY_neg

; Sound ON
	ldi		SOUND_L,0xF0	;ǂƂ̏Փˉ
	ldi		SOUND_H,0xFF

Next_03:
	rcall	SRAM_CLR

; {[ʒu̕\
	mov		LED_X,ON_X		;{[W̃Zbg
	mov		LED_Y,ON_Y

	rcall	SRAM_XY_SET		;\

; EEPROM ̃f[^ǂݏo
;  STEG ɐݒ肵AhXf[^ǂݍ
	out		EEAR,STEG
	ldi		tmp,0x01
	out		EECR,tmp
	in		tmp,EEDR

; 4bit  4bit 𕪗
	mov		PT_X,tmp
	mov		PT_Y,tmp
	andi	PT_Y,0x0F
	swap	PT_X
	andi	PT_X,0x0F

; ^[Qbgʒu̕\
	mov		LED_X,PT_X
	mov		LED_Y,PT_Y
	rcall	SRAM_XY_SET

; ^[Qbgƃ{[̏Փ˔
	cp		PT_X,ON_X
	brne	Next_L06		;if PT_X != ON_X then goto Next_L06

	cp		PT_Y,ON_Y
	brne	Next_L06		;if PT_Y != ON_Y then goto Next_L06

;
; Փ˂̏ꍇ͎̃^[QbgI
	inc		STEG			;^[Qbg̔ԍ
	ldi		tmp,0x7F		;^[Qbgԍ 0x00 - 0x7F
	and		STEG,tmp

; Sound ON	Փˉ
	ldi		SOUND_L,0xAA
	ldi		SOUND_H,0xAA

; Փ˂ꍇ͑x𔽓]
	rcall	VX_neg
	rcall	VY_neg

Next_L06:
	ldi		jmode,0x00
	rjmp	JMODE_END0


;==========================================================
; =========================================================
; jmode == 30
; =========================================================
JMODE_30:
	ldi		tmp,0b11111111
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111111
	out		LED_C9_C14,tmp

	rjmp	JMODE_END

;==========================================================
; =========================================================
; jmode == 31
; =========================================================
JMODE_31:
	ldi		tmp,0b11111111
	out		LED_C1_C8,tmp
	ldi		tmp,0b11111111
	out		LED_C9_C14,tmp

	mov		STEG,STEG0
	rcall	SRAM_CLR
	rcall	EEPROM_XY_SET
	rcall	EEPROM_XY_SET
	rcall	EEPROM_XY_SET
	rcall	EEPROM_XY_SET

; LTIME == 0 ŉo
	cpi		LTIM,0x00
	brne	JMODE_31_0		;if LTIM != 0 then JMODE_31_0

	ldi		SOUND_L,0xAA	;f[^
	ldi		SOUND_H,0xAA

JMODE_31_0:
	inc		LTIM			;LTIM CNg
	
; LTIME`FbN
	cpi		LTIM,0x10
	brne	JMODE_31_1		;if LTIM != 0x10 then JMODE_31_1

; LTIME  0x10 ɂȂ LMODE CNg
	ldi		LTIM,0x00
	inc		LMODE
	ldi		tmp,0x04		;\p SRAM AhXύX
	add		STEG0,tmp

; LMODE ̃`FbN
	cpi		LMODE,0x07
	brne	JMODE_31_1		;if LMODE != 0x07 then JMODE_31_1

; LMODE == 0x07  jmode  0x20 Ƃx菈Ɉڂ
	ldi		jmode,0x20
	rjmp	JMODE_END0

JMODE_31_1:
; LMODE != 0x07  jmode  0x10 ɖ߂
	ldi		jmode,0x10
	rjmp	JMODE_END0

; =========================================================
; JMODE_END
; =========================================================
JMODE_END:

	inc		jmode

JMODE_END0:
; =========================================================
; R1 - R15 data set
	ld	tmp_L,Z+			;SRAM \f[^[h
	out	LED_R1_R8,tmp_L
	
	ld	tmp,Z+				;SRAM \f[^[h
	ori	tmp,0x80

	sec

; SOUND_H/L ̃rbgɍ킹ĉo
	ror	SOUND_H
	ror	SOUND_L
	brcs	SOUND_OFF	;if Sound OFF then SOUND_00
	andi	tmp,0x7F

SOUND_OFF:
	out	LED_R9_R15,tmp

	reti				; 荞ݏ[`I


;==========================================================
; =========================================================
; jmode == 32
; =========================================================
JMODE_32:
	ldi		YL,0xA0			; xi[SRAM AhXݒ
	ldi		YH,0x00

	rcall	XOUT_COUNT		; x(Xj

	st		Y+,tmp_L		; xi[
	st		Y+,tmp_H

	inc		jmode
	reti					; 荞ݏ[`I

;==========================================================
; =========================================================
; jmode == 33
; =========================================================
JMODE_33:

	rcall	YOUT_COUNT		; x(Xj

	st		Y+,tmp_L		; xi[
	st		Y+,tmp_H

	ldi		jmode,0x00		; Q[Jn

	ldi	SOUND_L,0x00		;Q[Jn
	ldi	SOUND_H,0xFF

	ldi	tmp,0x00			; SRAM QƃAhX^[Qbg
	mov	STEG,tmp			; f[^ɐݒ

; =========================================================
; X,Y,VX,VY,AX,AY ̏
; =========================================================
	ldi	tmp,0x00
	mov	AXL_reg,tmp
	mov	AXH_reg,tmp
	mov	AYL_reg,tmp
	mov	AYH_reg,tmp

	mov	VXL_reg,tmp
	mov	VXH_reg,tmp
	mov	VYL_reg,tmp
	mov	VYH_reg,tmp

	ldi	tmp,0x01			;\ʒu
	mov	XH_reg,tmp
	mov	YH_reg,tmp
	ldi	tmp,0xC0
	mov	YL_reg,tmp
	mov	XL_reg,tmp

	ldi	ON_X,0x07
	ldi	ON_Y,0x07

	reti				; 荞ݏ[`I

;==========================================================
; =========================================================
; \p
; =========================================================
EEPROM_XY_SET:
	out		EEAR,STEG
	ldi		tmp,0x01
	out		EECR,tmp
	in		tmp,EEDR
	mov		PT_X,tmp
	mov		PT_Y,tmp
	andi	PT_Y,0x0F
	swap	PT_X
	andi	PT_X,0x0F

	mov		LED_X,PT_X
	mov		LED_Y,PT_Y

	rcall	SRAM_XY_SET

	inc		STEG

	ret

; =========================================================
; =========================================================
; Xout JEg
; =========================================================
XOUT_COUNT:

; =========================================================
; Xout  Low - High - Low ƕωp^[
; High ̊ԃJEgs
; =========================================================
; Xout  Low ɂȂ܂ő҂
PC6_LOP01:
	sbic	PINC,6			;if PORTC.6 == 0 then skip
	rjmp	PC6_LOP01		;if PORTC.6 == 1 then goto PC6_LOP01

; Xout  HighɂȂ܂ő҂
PC6_LOP02:
	sbis	PINC,6			;if PORTC.6 == 1 then skip
	rjmp	PC6_LOP02		;if PORTC.6 == 0 then goto PC6_LOP02

; TCNT1 ꎞ~
	ldi	tmp,0x00
	out	TCCR1B,tmp

; Xout  High
; TCNT1 ̏
	ldi		tmp,0x00
	out		TCNT1L,tmp
	out		TCNT1H,tmp

; TCNT1 JEgĊJ
	ldi	tmp,(1<<CS11)
	out	TCCR1B,tmp

; Xout  Low ɂȂ܂ő҂
PC6_LOP03:
	sbic	PINC,6			;if PORTC.6 == 0 then skip
	rjmp	PC6_LOP03		;if PORTC.6 == 1 then goto PC6_LOP03

; =========================================================
; Xout High̎ԁi TCNT1  tmp_H/LɃZbgj
; =========================================================
	in	tmp_H,TCNT1H
	in	tmp_L,TCNT1L

; TCNT1 JEgĊJ
	ldi	tmp,(1<<CS11)
	out	TCCR1B,tmp

	ret

; =========================================================
; =========================================================
; Yout JEg
; =========================================================
YOUT_COUNT:

; =========================================================
; Xout  Low - High - Low ƕωp^[
; High ̊ԃJEgs
; =========================================================
; Yout  Low ɂȂ܂ő҂
PC7_LOP01:
	sbic	PINC,7			;if PORTC.7 == 0 then skip
	rjmp	PC7_LOP01		;if PORTC.7 == 1 then goto PC7_LOP01

; Yout  HighɂȂ܂ő҂
PC7_LOP02:
	sbis	PINC,7			;if PORTC.7 == 1 then skip
	rjmp	PC7_LOP02		;if PORTC.7 == 0 then goto PC7_LOP02

; TCNT1 ꎞ~
	ldi	tmp,0x00
	out	TCCR1B,tmp

; Yout  High
; TCNT1 ̏
	ldi		tmp,0x00
	out		TCNT1L,tmp
	out		TCNT1H,tmp

; TCNT1 JEgĊJ
	ldi	tmp,(1<<CS11)
	out	TCCR1B,tmp

; Yout  Low ɂȂ܂ő҂
PC7_LOP03:
	sbic	PINC,7			;if PORTC.7 == 0 then skip
	rjmp	PC7_LOP03		;if PORTC.7 == 1 then goto PC7_LOP03

; TCNT1 ꎞ~
	ldi	tmp,0x00
	out	TCCR1B,tmp

; =========================================================
; Yout High̎ԁi TCNT1  tmp_H/LɃZbgj
; =========================================================
	in	tmp_H,TCNT1H
	in	tmp_L,TCNT1L

;Timer1 Prescale CK/8
	ldi	tmp,(1<<CS11)
	out	TCCR1B,tmp

	ret

; =========================================================
; =========================================================
; SRAM clr sub \pSRAM ̃NA
; =========================================================
SRAM_CLR:
	ldi	ZH,0x00
	ldi	ZL,0x60
	ldi	tmp,0x00
LOP1:
	st	Z+,tmp
	cpi	ZL,0x7E
	brne	LOP1		;if ZL != 0x7E then LOP1

	ret

; =========================================================
; =========================================================
; XYWɑΉSRAM 1bitZbg
; =========================================================
SRAM_XY_SET:

	ldi		tmp,0x00
	ldi		tmp_L,0x00
	ldi		tmp_H,0x00
	sec
LBL11:
	rol		tmp_L
	rol		tmp_H
	cp		tmp,LED_X
	breq	LBL10			;if tmp == X_reg then goto LBL10
	inc		tmp				;if tmp != X_reg then tmp ++
	clc
	rjmp	LBL11

LBL10:

	ldi		YH,0x00
	mov		YL,LED_Y
	lsl		YL				; YL *= 2
	ldi		tmp,0x60
	add		YL,tmp

	ld		tmp,Y
	or		tmp_L,tmp
	st		Y+,tmp_L
	ld		tmp,Y
	or		tmp_H,tmp
	st		Y,tmp_H

	ret

; =========================================================
; =========================================================
; VX ̔]
; =========================================================
VX_neg:
	ldi		tmp_L,0x00
	ldi		tmp_H,0x00
	sub		tmp_L,VXL_reg
	sbc		tmp_H,VXH_reg
	mov		VXL_reg,tmp_L
	mov		VXH_reg,tmp_H
	ret

; =========================================================
; =========================================================
; VY ̔]
; =========================================================
VY_neg:
	ldi		tmp_L,0x00
	ldi		tmp_H,0x00
	sub		tmp_L,VYL_reg
	sbc		tmp_H,VYH_reg
	mov		VYL_reg,tmp_L
	mov		VYH_reg,tmp_H
	ret

; =========================================================
; =========================================================
; jmode gWve[u
; rcall ɃX^bNɑޔAhX jmode Z
; =========================================================
TABLE_JMODE:
	push	ZL				; Zޔ
	push	ZH
	in		ZL,SPL
	in		ZH,SPH
	ld		tmp_H,Z+		; ޔAhXʒuɈړ
	ld		tmp_H,Z+
	ld		tmp_H,Z+
	ld		tmp_H,Z+
	ld		tmp_L,Z
	
	add		tmp_L,jmode		; AhXjmode Z
	ldi		tmp,0x00
	adc		tmp_H,tmp

	st		Z,tmp_L			; X^bNɖ߂
	st		-Z,tmp_H
	pop		ZH
	pop		ZL
	ret

; =========================================================
; =========================================================
; f[^pEEPROM
; =========================================================

; ^[Qbgf[^
; ̃f[^ύXƃ^[QbgʒuύX邱Ƃł
; ܂B4bit  R1-R15(0x0* - 0xE*) A
; 4bit  C1-C14(0x*0 - 0x*D) w
;
; Excel ̗֐ō쐬
.ESEG
	.DB 13
	.DB 147
	.DB 103
	.DB 118
	.DB 2
	.DB 162
	.DB 75
	.DB 18
	.DB 81
	.DB 229
	.DB 35
	.DB 164
	.DB 185
	.DB 61
	.DB 138
	.DB 203
	.DB 128
	.DB 182
	.DB 97
	.DB 91
	.DB 228
	.DB 173
	.DB 131
	.DB 132
	.DB 105
	.DB 141
	.DB 160
	.DB 88
	.DB 151
	.DB 87
	.DB 45
	.DB 236
	.DB 150
	.DB 146
	.DB 165
	.DB 144
	.DB 213
	.DB 17
	.DB 182
	.DB 229
	.DB 232
	.DB 228
	.DB 149
	.DB 41
	.DB 187
	.DB 214
	.DB 212
	.DB 13
	.DB 50
	.DB 215
	.DB 189
	.DB 48
	.DB 13
	.DB 148
	.DB 24
	.DB 26
	.DB 205
	.DB 136
	.DB 221
	.DB 50
	.DB 107
	.DB 72
	.DB 19
	.DB 86
	.DB 59
	.DB 155
	.DB 148
	.DB 25
	.DB 149
	.DB 58
	.DB 203
	.DB 50
	.DB 92
	.DB 180
	.DB 20
	.DB 128
	.DB 26
	.DB 74
	.DB 55
	.DB 99
	.DB 154
	.DB 0
	.DB 122
	.DB 37
	.DB 154
	.DB 19
	.DB 11
	.DB 122
	.DB 42
	.DB 22
	.DB 27
	.DB 38
	.DB 26
	.DB 235
	.DB 59
	.DB 23
	.DB 3
	.DB 173
	.DB 10
	.DB 40
	.DB 116
	.DB 237
	.DB 9
	.DB 219
	.DB 177
	.DB 203
	.DB 22
	.DB 205
	.DB 41
	.DB 34
	.DB 130
	.DB 117
	.DB 2
	.DB 183
	.DB 193
	.DB 113
	.DB 96
	.DB 215
	.DB 9
	.DB 27
	.DB 98
	.DB 8
	.DB 129
	.DB 150
	.DB 130
	.DB 92
	.DB 12
	.DB 217

; \f[^
; ̃f[^ύXƏ\ύX邱Ƃł
; ܂B4bit  R1-R15(0x0* - 0xE*) A
; 4bit  C1-C14(0x*0 - 0x*D) w
;0
	.DB	0x00
	.DB	0x0E
	.DB	0xE0
	.DB	0xEE

;1
	.DB	0x11
	.DB	0x1D
	.DB	0xD1
	.DB	0xDD

;2
	.DB	0x22
	.DB	0x2C
	.DB	0xC2
	.DB	0xCC

;3
	.DB	0x33
	.DB	0x3B
	.DB	0xB3
	.DB	0xBB

;4
	.DB	0x44
	.DB	0x4A
	.DB	0xA4
	.DB	0xAA

;5
	.DB	0x55
	.DB	0x59
	.DB	0x95
	.DB	0x99

;6
	.DB	0x66
	.DB	0x68
	.DB	0x86
	.DB	0x88
